# Nocturn9x Private Cloud - Ecosystem overview

This repository aims to lay down the structure of the private cloud to allow for easy addition of nodes by replicating our configuration.

## General Security Considerations

The most important thing when configuring a node is security. For this reason, a node added to the network that hosts sensitive
user data **must** implement some sort of security system the likes of SELinux. Nodes that host non-sensitive applications such as pasting
services and minecraft servers *may* skip this requirement. A sensitive application is defined as one storing any sort of non-anonymized,
user-identifying information, either temporarily or permanently, in any way, shape or form. Sensitive applications that do not make use of
best practices to secure user data (like encryption) will not be hosted on the network unless a secure workaround to such limitation exists.

## Node Setup

For simplicity as well as security purposes, most (if not all) services running on the current node(s) are dockerized or otherwise containerized in some manner.
It is advised for other node owners to follow this practice to simplify application deployment as well as confining their scope to contain potential security
issues that may arise.

## Network Setup

The network is set up as a collection of internet-facing servers and to which traffic is routed and forwarded from a main instance for conveniency purposes,
but individual nodes can (and should) have a fallback domain to make them reachable should the central node be offline. Nodes are assigned codenames, and
the current set of codenames is already taken:
- Centria (root instance, managed by me)
- Norlangarth (secondary instance, managed by [Art](https://git.nocturn9x.space/prod2))
- Aincrad (non-sensitive instance, managed by [Davide](https://git.nocturn9x.space/DavideGalilei))
- Neon (non-sensitive instance, managed by [Francesco](https://git.nocturn9x.space/francescomasala))
- Cardina (tertiary instance, managed by [Mark](https://git.nocturn9x.space/mark))

Other potential future codenames are listed below, in no particular order:
- Zakkaria
- Rulid
- Swilvane
- Alne
- Jotunheimr
- Thrymheim
- Legrue
- Yggdrasil
- Lindarth
- Myujen
- Algade
- Rovia
- Ronbaru
- Collinia
- Danac
- Floria
- Urbus

Codenames are assigned by me ([nocturn9x](https://git.nocturn9x.space/nocturn9x)) for an added coolness™️ factor, but you may pick one from the list
as well and I'll most likely grant it.

__Note__: I'm a huge SAO nerd.

__Note 2__: I know it's supposed to be Centoria, but I'm used to calling it Centria. Deal with it.

__Note 3__: Jotunheimr has no umlaut for a reason. ASCII is simple.

__Note 4__: Bonus points if your server's hostname matches its codename.

## Subdomains

Each service is assigned a subdomain of the `nocturn9x.space` domain to make it reachable from Centria, but each node may have its own (sub)domain(s) and we
encourage node owners to publish them in order to make the network more resilient should Centria be offline.

## Usage Policies

I don't think I need to specify detailed usage policies if you've come this far, but the basics are:
- Don't be a dick. Access to this service is provided on an approval-only basis and is free of charge for everyone
- I fund these services out of my own pocket and with donations, so please don't abuse them
- If you really _need_ to post leaked source code to this git service, at least make it private. I won't shut it down if it is
- Try hosting any kind of child pornography material and you'll see me out of your house with an M4 faster than you can say the word "fuck"
- Be nice to others
- Don't act entitled (unless you pay for a specific service, in which case be a dick I guess). The services are provided on a best-effort basis

Other than that, if you have basic common sense and follow the netiquette (at least even partially), do pretty much what you want.

## FAQ

### Can you host X?

Woah, slow down there kiddo. Feel free to propose the idea to me (either with a PR to this repo or by contacting me [on Telegram](https://t.me/nocturn9x)),
but there's no guarantee I'll approve your request. We host services based on how useful they are to them or if they're cool

### I feel offended by X! Can you remove it?

Then I feel offended by you feeling offended. Fuck off, the door is always open both to come in and to leave

### I don't like SAO!

This is not a question, but you're an idiot regardless

### I found some illegal content, what do I do?

Report it to me [on Telegram](https://t.me/nocturn9x) ASAP and I'll deal with it. If you get us banned by filing a report
to our provider I'll personally kick you in the butt and ban you from using our services. Beware

### Service X is down, can you fix it?

We have real-time uptime notifications in our private management group. If you noticed it's down, we most likely did before you
and are already working on fixing the problem (because we love you even if you're a cunt). Just don't act entitled, I'm literally
giving you freebies here, Jeez

### Can I help you with management?

Ehh, it depends. We're kind of full at the moment, but if you have a good idea and/or a particular skillset do reach to me [on Telegram](https://t.me/nocturn9x)
and we'll see what can be done

### How can I host a node of my own?

Instructions on how to host your own node will be coming soon. Thanks for being Awesome™️, by the way

### My question is not here, what do I do?

[Reach out](https://t.me/nocturn9x)

### Will you spy on me?

No. I honestly could not care less about you, to be honest. If you don't trust me it's fine, go use Google or host your own
crap I guess

### Did anyone actually ask these questions?

No, I made them up. What are you, braindead?
